diff --git a/lib/hive/tui/views/task_info.rb b/lib/hive/tui/views/task_info.rb
new file mode 100644
index 00000000..5ebe9876
--- /dev/null
+++ b/lib/hive/tui/views/task_info.rb
@@ -0,0 +1,185 @@
+require "hive/tui/styles"
+require "hive/tui/text"
+
+module Hive
+  module Tui
+    module Views
+      # Fixed-height, read-only task information panel. It has no scroll
+      # state: content beyond the terminal row budget is replaced by a
+      # visible ellipsis while the close hint remains anchored at bottom.
+      module TaskInfo
+        CLOSE_HINT = "[q/Esc/i] close".freeze
+        Line = Data.define(:text, :style)
+
+        module_function
+
+        def render(model)
+          state = model.task_info_state
+          return "" if state.nil?
+
+          width = [ model.cols.to_i - 1, 1 ].max
+          height = [ model.rows.to_i, 1 ].max
+          capacity = [ height - 1, 0 ].max
+          content = content_lines(state, width, limit: capacity + 1)
+          visible = fit_content(content, width, capacity).map { |line| render_line(line) }
+          visible << Styles::HINT.render(truncate(CLOSE_HINT, width))
+          visible.join("\n")
+        end
+
+        def content_lines(state, width, limit:)
+          title = state.info&.slug
+          title = state.row.slug if title.nil? && state.row&.respond_to?(:slug)
+          lines = []
+          append_line(lines, truncate("Task info · #{safe(title)}", width),
+                      style: Styles::HEADER, limit: limit)
+          append_line(lines, "", limit: limit)
+
+          case state.status
+          when :loading
+            append_line(lines, "Loading task info…", limit: limit)
+          when :failed
+            append_line(lines, "Could not load task info", limit: limit)
+            append_wrapped(lines, state.error.to_s, width, limit: limit)
+          when :loaded
+            append_loaded_lines(lines, state.info, width, limit: limit)
+          else
+            append_line(lines, "Task info unavailable", limit: limit)
+          end
+          lines
+        end
+
+        def append_loaded_lines(lines, info, width, limit:)
+          unless info
+            append_line(lines, "Task info unavailable", limit: limit)
+            return
+          end
+
+          append_wrapped(lines, "Slug: #{info.slug}", width, limit: limit)
+          append_wrapped(lines, "Stage: #{info.stage}", width, limit: limit)
+          append_wrapped(lines, "Created: #{info.created_at}", width, limit: limit)
+          append_wrapped(lines, "Task folder: #{info.task_folder}", width, limit: limit)
+          append_wrapped(lines, "Latest log: #{info.latest_log_path}", width, limit: limit)
+          append_line(lines, "", limit: limit)
+          append_line(lines, truncate("Original idea", width),
+                      style: Styles::HEADER, limit: limit)
+          append_wrapped(lines, info.original_text, width, limit: limit)
+          if info.extra_label
+            append_line(lines, "", limit: limit)
+            append_line(lines, truncate(safe(info.extra_label), width),
+                        style: Styles::HEADER, limit: limit)
+            append_wrapped(lines, info.extra_content.to_s, width, limit: limit)
+          end
+        end
+
+        def fit_content(lines, width, capacity)
+          return [] if capacity <= 0
+          return lines if lines.length <= capacity
+
+          visible = lines.first(capacity)
+          visible[-1] = visible.last.with(text: ellipsis_line(visible.last.text, width))
+          visible
+        end
+
+        def ellipsis_line(line, width)
+          clean = truncate(line, width)
+          return "…" if width <= 1
+          return "#{clean}…" if display_width(clean) < width
+
+          "#{take_cells(clean, width - 1)}…"
+        end
+
+        def wrap(text, width, limit:)
+          return [] if limit <= 0
+
+          wrapped = []
+          saw_line = false
+          text.to_s.each_line(chomp: true) do |line|
+            saw_line = true
+            clean = safe(line)
+            if clean.empty?
+              wrapped << ""
+            else
+              wrapped.concat(wrap_line(clean, width, limit - wrapped.length))
+            end
+            break if wrapped.length >= limit
+          end
+          wrapped << "" unless saw_line
+          wrapped.first(limit)
+        end
+
+        def wrap_line(line, width, limit)
+          chunks = []
+          current = +""
+          current_width = 0
+          line.each_grapheme_cluster do |cluster|
+            cluster_width = display_width(cluster)
+            if cluster_width > width
+              chunks << current unless current.empty?
+              chunks << "…" if chunks.length < limit
+              current = +""
+              current_width = 0
+            elsif current_width + cluster_width > width
+              chunks << current
+              current = +cluster
+              current_width = cluster_width
+            else
+              current << cluster
+              current_width += cluster_width
+            end
+            break if chunks.length >= limit
+          end
+          chunks << current if chunks.length < limit && !current.empty?
+          chunks
+        end
+
+        def append_line(lines, text, style: nil, limit:)
+          return if lines.length >= limit
+
+          lines << Line.new(text: text, style: style)
+        end
+
+        def append_wrapped(lines, text, width, limit:)
+          remaining = limit - lines.length
+          return if remaining <= 0
+
+          wrap(text, width, limit: remaining).each do |line|
+            lines << Line.new(text: line, style: nil)
+          end
+        end
+
+        def render_line(line)
+          line.style ? line.style.render(line.text) : line.text
+        end
+
+        def safe(text)
+          Hive::Tui::Text.sanitize(text)
+        end
+
+        def truncate(text, width)
+          return "" if width <= 0
+          return text if display_width(text) <= width
+          return "…" if width == 1
+
+          "#{take_cells(text, width - 1)}…"
+        end
+
+        def take_cells(text, width)
+          result = +""
+          used = 0
+          text.each_grapheme_cluster do |cluster|
+            cluster_width = display_width(cluster)
+            break if used + cluster_width > width
+
+            result << cluster
+            used += cluster_width
+          end
+          result
+        end
+
+        def display_width(text)
+          Lipgloss.width(text)
+        end
+      end
+    end
+  end
+end
diff --git a/test/e2e/lib/repro_script_writer.rb b/test/e2e/lib/repro_script_writer.rb
index 2264457a..c3119a6d 100644
--- a/test/e2e/lib/repro_script_writer.rb
+++ b/test/e2e/lib/repro_script_writer.rb
@@ -9,7 +9,7 @@ require_relative "string_expander"
 module Hive
   module E2E
     class ReproScriptWriter
-      LIVE_TMUX_KINDS = %w[tui_keys tui_expect wait_subprocess].freeze
+      LIVE_TMUX_KINDS = %w[tui_keys tui_expect wait_subprocess wait_tui_exit].freeze
 
       def initialize(scenario_dir:, sandbox_dir:, run_home:, steps:, failed_index:, scenario_name: nil, expander_context: nil)
         @scenario_dir = scenario_dir
diff --git a/test/e2e/lib/scenario_parser.rb b/test/e2e/lib/scenario_parser.rb
index 25f107c1..c05aeff8 100644
--- a/test/e2e/lib/scenario_parser.rb
+++ b/test/e2e/lib/scenario_parser.rb
@@ -18,7 +18,7 @@ module Hive
 
       STEP_KINDS = %w[
         cli tui_keys tui_expect state_assert json_assert seed_state write_file
-        register_project wait_subprocess editor_action log_assert ruby_block
+        register_project wait_subprocess wait_tui_exit editor_action log_assert ruby_block
       ].freeze
 
       REQUIRED_KEYS = {
diff --git a/test/e2e/lib/scenario_parser_test.rb b/test/e2e/lib/scenario_parser_test.rb
index 6a4b5d27..09644182 100644
--- a/test/e2e/lib/scenario_parser_test.rb
+++ b/test/e2e/lib/scenario_parser_test.rb
@@ -61,6 +61,22 @@ class E2EScenarioParserTest < Minitest::Test
     end
   end
 
+  def test_wait_tui_exit_step_parses_with_timeout
+    Dir.mktmpdir("scenario") do |dir|
+      path = File.join(dir, "wait.yml")
+      File.write(path, <<~YAML)
+        name: wait_ok
+        steps:
+          - kind: wait_tui_exit
+            timeout: 5
+      YAML
+
+      scenario = Hive::E2E::ScenarioParser.parse(path)
+      assert_equal "wait_tui_exit", scenario.steps.first.kind
+      assert_equal 5, scenario.steps.first.args["timeout"]
+    end
+  end
+
   def test_rejects_unsafe_scenario_names_before_runner_uses_paths
     [ "../bad", "/tmp/bad", "nested/name", ".", "bad name" ].each do |name|
       Dir.mktmpdir("scenario") do |dir|
diff --git a/test/e2e/lib/step_executor.rb b/test/e2e/lib/step_executor.rb
index ce02c76d..37afb961 100644
--- a/test/e2e/lib/step_executor.rb
+++ b/test/e2e/lib/step_executor.rb
@@ -245,6 +245,11 @@ module Hive
         tmux.wait_for_subprocess_exit(timeout: (step.args["timeout"] || 30.0).to_f)
       end
 
+      def step_wait_tui_exit(step)
+        tmux = @tmux_lifecycle.start_session
+        tmux.wait_for_tui_exit(timeout: (step.args["timeout"] || 30.0).to_f)
+      end
+
       def step_editor_action(step)
         run_cli_step(step, env_overrides: { "EDITOR" => Paths.editor_shim })
       end
diff --git a/test/e2e/lib/step_executor_test.rb b/test/e2e/lib/step_executor_test.rb
index d52e1003..516030d1 100644
--- a/test/e2e/lib/step_executor_test.rb
+++ b/test/e2e/lib/step_executor_test.rb
@@ -224,4 +224,24 @@ class E2EStepExecutorTest < Minitest::Test
       assert_equal 1, report_for(runs_dir)["summary"]["passed"]
     end
   end
+
+  def test_wait_tui_exit_delegates_to_foreground_tui_lifecycle
+    observed_timeout = nil
+    tmux = Object.new
+    tmux.define_singleton_method(:wait_for_tui_exit) { |timeout:| observed_timeout = timeout }
+    lifecycle = Object.new
+    lifecycle.define_singleton_method(:start_session) { tmux }
+    executor = Hive::E2E::StepExecutor.allocate
+    executor.instance_variable_set(:@tmux_lifecycle, lifecycle)
+    step = Hive::E2E::Step.new(
+      kind: "wait_tui_exit",
+      args: { "timeout" => 5 },
+      description: "",
+      position: 1
+    )
+
+    executor.send(:step_wait_tui_exit, step)
+
+    assert_equal 5.0, observed_timeout
+  end
 end
diff --git a/test/e2e/lib/tmux_driver.rb b/test/e2e/lib/tmux_driver.rb
index 84142243..3843296a 100644
--- a/test/e2e/lib/tmux_driver.rb
+++ b/test/e2e/lib/tmux_driver.rb
@@ -19,6 +19,15 @@ module Hive
 
       class DeadSession < StandardError; end
       class PaneCollapsedError < StandardError; end
+      class TuiFailed < StandardError
+        attr_reader :exit_code
+
+        def initialize(exit_code:)
+          @exit_code = exit_code
+          detail = exit_code.nil? ? "without a recorded exit status" : "with exit #{exit_code}"
+          super("tui exited #{detail}")
+        end
+      end
       class TmuxCommandTimeout < StandardError
         attr_reader :stdout, :stderr, :elapsed
 
@@ -96,6 +105,13 @@ module Hive
         raise "tmux new-session failed: #{err.empty? ? out : err}" unless status.success?
 
         @tmux_session_id = out.strip
+        option_out, option_err, option_status = capture_command(*(base_args + [
+          "set-window-option", "-t", @session_name, "remain-on-exit", "on"
+        ]))
+        unless option_status.success?
+          detail = option_err.empty? ? option_out : option_err
+          raise "tmux remain-on-exit setup failed: #{detail}"
+        end
         @started = true
       end
 
@@ -222,6 +238,15 @@ module Hive
         wait_for_pane_dead(timeout: timeout, interval: interval)
       end
 
+      # Wait for the foreground TUI itself to terminate. This is distinct
+      # from wait_for_subprocess_exit: TUI workflow children are detached
+      # and observed through BEGIN/END markers while `q` ends the pane's
+      # foreground process without writing a subprocess marker.
+      def wait_for_tui_exit(timeout: 30.0, interval: 0.1)
+        start
+        wait_for_pane_dead(timeout: timeout, interval: interval)
+      end
+
       def wait_for_subprocess_log(timeout:, interval:)
         started_at = monotonic_time
         begin_id = nil
@@ -265,10 +290,17 @@ module Hive
         started_at = monotonic_time
         loop do
           out, err, status = capture_command(*(base_args + [
-            "list-panes", "-t", @session_name, "-F", "\#{pane_dead}"
+            "list-panes", "-t", @session_name, "-F", "\#{pane_dead} \#{pane_dead_status}"
           ]))
-          raise "tmux list-panes failed: #{err.empty? ? out : err}" unless status.success?
-          return :ok if out.lines.first.to_s.strip == "1"
+          unless status.success?
+            unless session_alive?
+              raise DeadSession, "tmux session #{@session_name} disappeared before its exit status was observed"
+            end
+
+            raise "tmux list-panes failed: #{err.empty? ? out : err}"
+          end
+          pane_dead, exit_status = out.lines.first.to_s.strip.split(/\s+/, 2)
+          return validate_tui_exit!(exit_status) if pane_dead == "1"
 
           elapsed = monotonic_time - started_at
           raise AnchorTimeout.new(anchor: "pane_dead", captured: out, elapsed: elapsed) if elapsed >= timeout
@@ -277,6 +309,13 @@ module Hive
         end
       end
 
+      def validate_tui_exit!(status)
+        exit_code = Integer(status, exception: false)
+        raise TuiFailed.new(exit_code: exit_code) unless exit_code&.zero?
+
+        :ok
+      end
+
       def cleanup
         capture_command(*(base_args + [ "kill-server" ]))
         @started = false
@@ -316,12 +355,16 @@ module Hive
       end
 
       def ensure_live!
-        _out, _err, status = capture_command(*(base_args + [ "has-session", "-t", @session_name ]))
-        return if status.success?
+        return if session_alive?
 
         raise DeadSession, "tmux session #{@session_name} is not running on #{@socket_name}"
       end
 
+      def session_alive?
+        _out, _err, status = capture_command(*(base_args + [ "has-session", "-t", @session_name ]))
+        status.success?
+      end
+
       def capture_command(*cmd, timeout: TMUX_COMMAND_TIMEOUT)
         started = monotonic_time
         Open3.popen3(*cmd, pgroup: true) do |stdin, stdout, stderr, wait_thr|
diff --git a/test/e2e/lib/tmux_driver_test.rb b/test/e2e/lib/tmux_driver_test.rb
index 6abd7761..0543802b 100644
--- a/test/e2e/lib/tmux_driver_test.rb
+++ b/test/e2e/lib/tmux_driver_test.rb
@@ -124,6 +124,24 @@ class E2ETmuxDriverTest < Minitest::Test
     end
   end
 
+  def test_start_keeps_dead_pane_to_observe_foreground_exit_status
+    driver = make_driver(session_name: "remain-on-exit")
+    successful_status = Struct.new(:success?).new(true)
+    commands = []
+    driver.define_singleton_method(:capture_command) do |*cmd, **_kwargs|
+      commands << cmd
+      output = cmd.include?("new-session") ? "$1\n" : ""
+      [ output, "", successful_status ]
+    end
+
+    driver.start
+
+    option_command = commands.find { |command| command.include?("set-window-option") }
+    assert option_command, "start must configure the pane before waiting on its exit"
+    assert_includes option_command, "remain-on-exit"
+    assert_includes option_command, "on"
+  end
+
   def test_wait_for_subprocess_exit_observes_log_marker_without_pane_death
     Dir.mktmpdir("tmux-subprocess") do |dir|
       log_path = File.join(dir, "hive-tui-subprocess.log")
@@ -152,6 +170,45 @@ class E2ETmuxDriverTest < Minitest::Test
     end
   end
 
+  def test_wait_for_tui_exit_rejects_session_disappearing_without_an_exit_status
+    driver = make_driver(session_name: "tui-exit")
+    driver.instance_variable_set(:@started, true)
+    failed_status = Struct.new(:success?).new(false)
+    driver.define_singleton_method(:capture_command) do |*_cmd, **_kwargs|
+      [ "", "can't find session", failed_status ]
+    end
+
+    assert_raises(Hive::E2E::TmuxDriver::DeadSession) do
+      driver.wait_for_tui_exit(timeout: 0.1, interval: 0.01)
+    end
+  end
+
+  def test_wait_for_tui_exit_rejects_nonzero_pane_status
+    driver = make_driver(session_name: "tui-crash")
+    driver.instance_variable_set(:@started, true)
+    successful_status = Struct.new(:success?).new(true)
+    driver.define_singleton_method(:capture_command) do |*_cmd, **_kwargs|
+      [ "1 7\n", "", successful_status ]
+    end
+
+    error = assert_raises(Hive::E2E::TmuxDriver::TuiFailed) do
+      driver.wait_for_tui_exit(timeout: 0.1, interval: 0.01)
+    end
+
+    assert_equal 7, error.exit_code
+  end
+
+  def test_wait_for_tui_exit_accepts_zero_pane_status
+    driver = make_driver(session_name: "tui-clean-exit")
+    driver.instance_variable_set(:@started, true)
+    successful_status = Struct.new(:success?).new(true)
+    driver.define_singleton_method(:capture_command) do |*_cmd, **_kwargs|
+      [ "1 0\n", "", successful_status ]
+    end
+
+    assert_equal :ok, driver.wait_for_tui_exit(timeout: 0.1, interval: 0.01)
+  end
+
   def test_wait_for_subprocess_exit_ignores_mismatched_end_marker
     Dir.mktmpdir("tmux-subprocess") do |dir|
       log_path = File.join(dir, "hive-tui-subprocess.log")
diff --git a/test/unit/tui/bubble_model_test.rb b/test/unit/tui/bubble_model_test.rb
index bfc3e63b..7152b94b 100644
--- a/test/unit/tui/bubble_model_test.rb
+++ b/test/unit/tui/bubble_model_test.rb
@@ -46,28 +46,6 @@ class HiveTuiBubbleModelTest < Minitest::Test
     old_editor.nil? ? ENV.delete("EDITOR") : ENV["EDITOR"] = old_editor
   end
 
-  def write_idea_md(dir, original_text:)
-    indented_original = original_text.lines.map { |line| "  #{line.chomp}" }
-    body = [
-      "---",
-      "slug: some-slug",
-      "created_at: 2026-05-20T00:00:00Z",
-      "original_text: |",
-      *indented_original,
-      "---",
-      "",
-      "# some-slug",
-      "",
-      original_text,
-      "",
-      "<!-- WAITING -->",
-      ""
-    ].join("\n")
-    path = File.join(dir, "idea.md")
-    File.write(path, body)
-    path
-  end
-
   def write_review_doc(path, accepted: false)
     mark = accepted ? "x" : " "
     File.write(path, "## High\n- [#{mark}] First finding: useful rationale\n")
@@ -345,18 +323,27 @@ class HiveTuiBubbleModelTest < Minitest::Test
     assert_includes out, "/auth"
   end
 
-  def test_view_composes_idea_preview_onto_grid_in_idea_preview_mode
+  def test_view_renders_task_info_without_underlying_grid
+    info = Hive::Tui::TaskInfo::Snapshot.new(
+      slug: "some-slug", stage: "2-brainstorm", created_at: "2026-05-22T00:00:00Z",
+      original_text: "original idea", task_folder: "/tmp/task", latest_log_path: "/tmp/task.log",
+      extra_label: "Brainstorm", extra_content: "artifact", warnings: [], source_paths: []
+    )
+    state = Hive::Tui::Model::TaskInfoState.new(
+      row: make_task_row, request_id: "request-1", status: :loaded, info: info
+    )
     @model = Hive::Tui::BubbleModel.new(
       hive_model: Hive::Tui::Model.initial.with(
-        mode: :idea_preview,
-        idea_preview_slug: "some-slug",
-        idea_preview_text: "original idea"
+        mode: :task_info,
+        task_info_state: state
       ),
       dispatch: @dispatch
     )
     out = @model.view
-    assert_includes out, "Idea for some-slug:"
+    assert_includes out, "Task info"
     assert_includes out, "original idea"
+    refute_includes out, "ProjectsPane"
+    refute_includes out, "[Tab] switch"
   end
 
   # Regression: paste-truncated / paste-timeout / overflow flashes
@@ -603,28 +590,34 @@ class HiveTuiBubbleModelTest < Minitest::Test
     refute_includes out, "[Enter] open",   "Enter is not only an open action"
   end
 
-  def test_default_footer_hint_omits_o_at_70_col_budget
-    # Plan R6: `[o] open` is included in the footer only if it fits
-    # the 70-col budget without wrapping or pushing primary actions
-    # onto a second line. At 70 cols the current hint string is
-    # already ~69 chars; adding ten more (separator + "[o] open")
-    # would exceed the budget. We rely on the `?` overlay for
-    # discoverability instead. This test pins that decision so a
-    # future contributor doesn't silently re-add the hint and break
-    # 70-col rendering.
+  def test_default_footer_hint_includes_info_between_help_and_quit
     hint = @model.send(:footer_hint)
-    assert_equal "[Tab] switch  [Enter] action  [n] new  [/] filter  [?] help  [q] quit",
-                 hint,
-                 "footer hint must remain the pre-`o` literal; `o` is documented in `?` only"
-    refute_includes hint, "[o] open",
-                    "70-col budget can't absorb `[o] open` alongside primary hints"
-    # Width guard: pin the actual character count so a future contributor
-    # who adds a hint and (correctly) bumps the literal above also has to
-    # acknowledge they're spending bytes against the 70-col budget. If
-    # this assertion fires alongside an updated literal, the contributor
-    # MUST verify default_footer truncation behavior at cols == 70.
-    assert hint.length <= 70,
-           "footer hint must fit the 70-col budget without truncation; got #{hint.length} chars"
+    expected = "[Tab] switch  [Enter] action  [n] new  [/] filter  [?] help  [i] info  [q] quit"
+
+    assert_equal expected, hint
+    assert_operator hint.index("[?] help"), :<, hint.index("[i] info")
+    assert_operator hint.index("[i] info"), :<, hint.index("[q] quit")
+    assert_equal 79, hint.length
+  end
+
+  def test_default_80_column_grid_renders_full_footer_on_one_line
+    @model = Hive::Tui::BubbleModel.new(
+      hive_model: Hive::Tui::Model.initial.with(cols: 80),
+      dispatch: @dispatch
+    )
+
+    footer = @model.view.lines(chomp: true).find { |line| line.include?("[Tab] switch") }
+
+    assert_equal @model.send(:footer_hint), footer
+    assert_equal 79, footer.length
+  end
+
+  def test_narrow_footer_is_truncated_without_wrapping
+    footer = @model.send(:default_footer, 69)
+
+    assert_equal 69, footer.length
+    assert footer.end_with?("…")
+    refute_includes footer, "\n"
   end
 
   def test_grid_mode_collapses_to_single_pane_below_min_cols
@@ -3658,118 +3651,105 @@ class HiveTuiBubbleModelTest < Minitest::Test
       "OpenTaskFolder must not dispatch any follow-up message — no auto-continue, no InputEditorExited"
   end
 
-  # ---- OpenIdeaPreview → bottom-strip preview (read-only) ----
-
-  def test_open_idea_preview_reads_original_text_and_enters_preview_mode
-    with_tmp_dir do |dir|
-      write_idea_md(dir, original_text: "Build task from user note")
-      row = make_task_row(folder: dir, slug: "some-slug")
-
-      _, cmd = @model.update(Hive::Tui::Messages::OpenIdeaPreview.new(row: row))
+  # ---- OpenTaskInfo → tracked asynchronous read-only load ----
 
-      assert_nil cmd
-      assert_equal :idea_preview, @model.hive_model.mode
-      assert_equal "Build task from user note", @model.hive_model.idea_preview_text
-      assert_equal "some-slug", @model.hive_model.idea_preview_slug
+  def test_open_task_info_enters_loading_before_worker_finishes
+    gate = Queue.new
+    loader = lambda do |_folder|
+      gate.pop
+      :loaded_info
     end
-  end
-
-  def test_open_idea_preview_flashes_when_folder_empty
-    row = make_task_row(folder: "")
+    @model = Hive::Tui::BubbleModel.new(
+      hive_model: Hive::Tui::Model.initial,
+      dispatch: @dispatch,
+      task_info_loader: loader
+    )
+    row = make_task_row
 
-    _, cmd = @model.update(Hive::Tui::Messages::OpenIdeaPreview.new(row: row))
+    _, cmd = @model.update(Hive::Tui::Messages::OpenTaskInfo.new(row: row))
 
     assert_nil cmd
-    assert_equal :grid, @model.hive_model.mode
-    assert_match(/no idea for some-slug/, @model.hive_model.flash.to_s)
-  end
-
-  def test_open_idea_preview_flashes_when_idea_md_missing
-    with_tmp_dir do |dir|
-      row = make_task_row(folder: dir)
-
-      _, cmd = @model.update(Hive::Tui::Messages::OpenIdeaPreview.new(row: row))
-
-      assert_nil cmd
-      assert_equal :grid, @model.hive_model.mode
-      assert_match(/no idea\.md for some-slug/, @model.hive_model.flash.to_s)
-    end
+    assert_equal :task_info, @model.hive_model.mode
+    assert_equal :loading, @model.hive_model.task_info_state.status
+    gate << true
+    @model.wait_for_background_threads
+    message = @messages.find { |item| item.is_a?(Hive::Tui::Messages::TaskInfoLoaded) }
+    refute_nil message
+    assert_equal @model.hive_model.task_info_state.request_id, message.request_id
   end
 
-  def test_open_idea_preview_flashes_when_original_text_missing
-    with_tmp_dir do |dir|
-      File.write(File.join(dir, "idea.md"), "---\nslug: some-slug\n---\n")
-      row = make_task_row(folder: dir)
+  def test_open_task_info_worker_dispatches_sanitized_failure
+    loader = ->(_folder) { raise Errno::ENOENT, "\e[31mgone\e[0m" }
+    @model = Hive::Tui::BubbleModel.new(
+      hive_model: Hive::Tui::Model.initial,
+      dispatch: @dispatch,
+      task_info_loader: loader
+    )
 
-      _, cmd = @model.update(Hive::Tui::Messages::OpenIdeaPreview.new(row: row))
+    @model.update(Hive::Tui::Messages::OpenTaskInfo.new(row: make_task_row))
+    @model.wait_for_background_threads
 
-      assert_nil cmd
-      assert_equal :grid, @model.hive_model.mode
-      assert_match(/idea has no original_text for some-slug/, @model.hive_model.flash.to_s)
-    end
+    message = @messages.find { |item| item.is_a?(Hive::Tui::Messages::TaskInfoFailed) }
+    refute_nil message
+    refute_includes message.error, "\e"
+    assert_match(/ENOENT/, message.error)
   end
 
-  def test_open_idea_preview_flashes_on_unreadable_idea_md
-    with_tmp_dir do |dir|
-      File.write(File.join(dir, "idea.md"), "---\noriginal_text: [broken\n---\n")
-      row = make_task_row(folder: dir)
-
-      _, cmd = @model.update(Hive::Tui::Messages::OpenIdeaPreview.new(row: row))
-
-      assert_nil cmd
-      assert_equal :grid, @model.hive_model.mode
-      assert_match(/could not read idea for some-slug/, @model.hive_model.flash.to_s)
+  def test_closing_task_info_cancels_the_superseded_loader_before_reopen
+    started = Queue.new
+    first_gate = Queue.new
+    calls = 0
+    loader = lambda do |_folder|
+      call = calls
+      calls += 1
+      started << call
+      first_gate.pop if call.zero?
+      :"loaded_info_#{call}"
     end
-  end
-
-  def test_open_idea_preview_does_not_dispatch_or_mutate_marker
-    with_tmp_dir do |dir|
-      idea_path = write_idea_md(dir, original_text: "Read only")
-      before = File.read(idea_path)
-      row = make_task_row(folder: dir)
-
-      _, cmd = @model.update(Hive::Tui::Messages::OpenIdeaPreview.new(row: row))
+    @model = Hive::Tui::BubbleModel.new(
+      hive_model: Hive::Tui::Model.initial,
+      dispatch: @dispatch,
+      task_info_loader: loader
+    )
 
-      assert_nil cmd
-      assert_empty @messages
-      assert_equal before, File.read(idea_path)
-    end
-  end
+    @model.update(Hive::Tui::Messages::OpenTaskInfo.new(row: make_task_row(slug: "first")))
+    assert_equal 0, started.pop
+    first_thread = @model.instance_variable_get(:@heal_threads).first
+    assert first_thread.alive?
 
-  def test_open_idea_preview_truncates_oversized_original_text
-    with_tmp_dir do |dir|
-      original = "x" * (Hive::Tui::Model::NEW_IDEA_BUFFER_MAX_CHARS + 20)
-      write_idea_md(dir, original_text: original)
-      row = make_task_row(folder: dir)
+    @model.update(Hive::Tui::Messages::BACK)
+    first_thread.join(0.5)
+    refute first_thread.alive?, "closing the panel must cancel its now-superseded loader"
 
-      _, cmd = @model.update(Hive::Tui::Messages::OpenIdeaPreview.new(row: row))
+    @model.update(Hive::Tui::Messages::OpenTaskInfo.new(row: make_task_row(slug: "second")))
+    assert_equal 1, started.pop
+    @model.wait_for_background_threads
 
-      assert_nil cmd
-      assert_equal :idea_preview, @model.hive_model.mode
-      assert_equal Hive::Tui::Model::NEW_IDEA_BUFFER_MAX_CHARS,
-                   @model.hive_model.idea_preview_text.length
-    end
+    tracked = @model.instance_variable_get(:@heal_threads)
+    assert_operator tracked.size, :<=, 1,
+      "rapid close/reopen must keep task-info loader workers bounded"
+    assert @messages.any? { |item| item.is_a?(Hive::Tui::Messages::TaskInfoLoaded) && item.info == :loaded_info_1 }
   end
 
-  def test_idea_preview_roundtrip_open_then_any_key_dismisses
-    with_tmp_dir do |dir|
-      write_idea_md(dir, original_text: "Roundtrip idea")
-      row = make_task_row(folder: dir)
-
-      _, open_cmd = @model.update(Hive::Tui::Messages::OpenIdeaPreview.new(row: row))
+  def test_grid_i_opens_modal_unmapped_key_is_noop_and_i_closes
+    row = make_task_row
+    @model = Hive::Tui::BubbleModel.new(
+      hive_model: Hive::Tui::Model.initial.with(snapshot: snapshot_with([ row ]), cursor: [ 0, 0 ]),
+      dispatch: @dispatch,
+      task_info_loader: ->(_folder) { :loaded_info }
+    )
 
-      assert_nil open_cmd
-      assert_equal :idea_preview, @model.hive_model.mode
-      assert_equal "Roundtrip idea", @model.hive_model.idea_preview_text
+    @model.update(Bubbletea::KeyMessage.new(key_type: 0, runes: [ "i".ord ]))
+    assert_equal :task_info, @model.hive_model.mode
+    selected_cursor = @model.hive_model.cursor
 
-      _, dismiss_cmd = @model.update(Bubbletea::KeyMessage.new(key_type: 0, runes: [ "x".ord ]))
+    @model.update(Bubbletea::KeyMessage.new(key_type: 0, runes: [ "x".ord ]))
+    assert_equal :task_info, @model.hive_model.mode
 
-      assert_nil dismiss_cmd
-      assert_equal :grid, @model.hive_model.mode
-      assert_nil @model.hive_model.idea_preview_text
-      assert_nil @model.hive_model.idea_preview_slug
-      assert_empty @messages
-    end
+    @model.update(Bubbletea::KeyMessage.new(key_type: 0, runes: [ "i".ord ]))
+    assert_equal :grid, @model.hive_model.mode
+    assert_equal selected_cursor, @model.hive_model.cursor
+    @model.wait_for_background_threads
   end
 
   # ---- OpenInAgent → configured agent foreground takeover ----
